using Microsoft.Deployment.WindowsInstaller;
using System.Diagnostics;
using System.IO;

namespace TestProject.Action
{
    /// <summary>
    /// Ŀ ׼
    /// </summary>
    public class CustomAction
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// α 
        /// </summary>
        private static ILogHelper _logHelper = null;

        /// <summary>
        /// ƿ μ
        /// </summary>
        private static readonly string _outlookProcessName = "OUTLOOK";

        /// <summary>
        /// ƿ ϸ
        /// </summary>
        private static readonly string _outlookFileName = "OUTLOOK.exe";

        /// <summary>
        /// ƿ μ  
        /// </summary>
        private static bool _isRunningOutlookProcess = false;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Static

        #region  - CustomAction()

        /// <summary>
        /// 
        /// </summary>
        static CustomAction()
        {
            #region α׷ 丮 θ Ѵ.

            string programDirectoryPath = "c:\\DSCore\\TestProject";

            #endregion
            #region α׷ 丮   Ѵ.

            if (!Directory.Exists(programDirectoryPath))
            {
                Directory.CreateDirectory(programDirectoryPath);
            }

            #endregion

            #region α 丮 θ Ѵ.

            string logDirectoryPath = Path.Combine(programDirectoryPath, "Log");

            #endregion
            #region α 丮   Ѵ.

            if (!Directory.Exists(logDirectoryPath))
            {
                Directory.CreateDirectory(logDirectoryPath);
            }

            #endregion
            #region α ۸ Ѵ.

            _logHelper = new FileLogHelper(logDirectoryPath, "test.log");

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region  ġ  óϱ - BeforeFirstInstall(session)

        /// <summary>
        ///  ġ  óϱ
        /// </summary>
        /// <param name="session"></param>
        /// <returns>׼ </returns>
        [CustomAction]
        public static ActionResult BeforeFirstInstall(Session session)
        {
            _logHelper?.WriteLog("BEGIN BEFORE FIRST INSTALL FUNCTION");

            RemoveOutlookProcess();

            _logHelper?.WriteLog("END BEFORE FIRST INSTALL FUNCTION");

            return ActionResult.Success;
        }

        #endregion
        #region  ġ  óϱ - AfterFirstInstall(session)

        /// <summary>
        ///  ġ  óϱ
        /// </summary>
        /// <param name="session"></param>
        /// <returns>׼ </returns>
        [CustomAction]
        public static ActionResult AfterFirstInstall(Session session)
        {
            _logHelper?.WriteLog("BEGIN AFTER FIRST INSTALL FUNCTION");

            ExecuteOutlookProcess();

            _logHelper?.WriteLog("END AFTER FIRST INSTALL FUNCTION");

            return ActionResult.Success;
        }

        #endregion

        #region   óϱ - BeforeMaintenance( session)

        /// <summary>
        ///   óϱ
        /// </summary>
        /// <param name="session"></param>
        /// <returns>׼ </returns>
        [CustomAction]
        public static ActionResult BeforeMaintenance(Session session)
        {
            _logHelper?.WriteLog("BEGIN BEFORE MAINTENANCE FUNCTION");

            RemoveOutlookProcess();

            _logHelper?.WriteLog("END BEFORE MAINTENANCE FUNCTION");

            return ActionResult.Success;
        }

        #endregion
        #region   óϱ - AfterMaintenance(session)

        /// <summary>
        ///   óϱ
        /// </summary>
        /// <param name="session"></param>
        /// <returns>׼ </returns>
        [CustomAction]
        public static ActionResult AfterMaintenance(Session session)
        {
            _logHelper?.WriteLog("BEGIN AFTER MAINTENANCE FUNCTION");

            ExecuteOutlookProcess();

            _logHelper?.WriteLog("END AFTER MAINTENANCE FUNCTION");

            return ActionResult.Success;
        }

        #endregion

        #region ׷̵  óϱ - BeforeUpgrade(session)

        /// <summary>
        /// ׷̵  óϱ
        /// </summary>
        /// <param name="session"></param>
        /// <returns>׼ </returns>
        [CustomAction]
        public static ActionResult BeforeUpgrade(Session session)
        {
            _logHelper?.WriteLog("BEGIN BEFORE UPGRADE FUNCTION");

            RemoveOutlookProcess();

            _logHelper?.WriteLog("END BEFORE UPGRADE FUNCTION");

            return ActionResult.Success;
        }

        #endregion
        #region ׷̵  óϱ - AfterUpgrade(session)

        /// <summary>
        /// ׷̵  óϱ
        /// </summary>
        /// <param name="session"></param>
        /// <returns>׼ </returns>
        [CustomAction]
        public static ActionResult AfterUpgrade(Session session)
        {
            _logHelper?.WriteLog("BEGIN AFTER UPGRADE FUNCTION");

            ExecuteOutlookProcess();

            _logHelper?.WriteLog("END AFTER UPGRADE FUNCTION");

            return ActionResult.Success;
        }

        #endregion

        #region ġ   óϱ - BeforeUninstall(session)

        /// <summary>
        /// ġ   óϱ
        /// </summary>
        /// <param name="session"></param>
        /// <returns>׼ </returns>
        [CustomAction]
        public static ActionResult BeforeUninstall(Session session)
        {
            _logHelper?.WriteLog("BEGIN BEFORE UNINSTALL FUNCTION");

            RemoveOutlookProcess();

            _logHelper?.WriteLog("END BEFORE UNINSTALL FUNCTION");

            return ActionResult.Success;
        }

        #endregion
        #region ġ   óϱ - AfterUninstall(session)

        /// <summary>
        /// ġ   óϱ
        /// </summary>
        /// <param name="session"></param>
        /// <returns>׼ </returns>
        [CustomAction]
        public static ActionResult AfterUninstall(Session session)
        {
            _logHelper?.WriteLog("BEGIN AFTER UNINSTALL FUNCTION");

            ExecuteOutlookProcess();

            _logHelper?.WriteLog("END AFTER UNINSTALL FUNCTION");

            return ActionResult.Success;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region ƿ μ ϱ - RemoveOutlookProcess()

        /// <summary>
        /// ƿ μ ϱ
        /// </summary>
        /// <returns>ó </returns>
        private static bool RemoveOutlookProcess()
        {
            try
            {
                Process[] processArray = Process.GetProcessesByName(_outlookProcessName);

                if(processArray.Length > 0)
                {
                    foreach(Process process in processArray)
                    {
                        process.Kill();
                    }

                    return true;
                }
                else
                {
                    return false;
                }
            }
            catch
            {
                return false;
            }
        }

        #endregion
        #region ƿ μ ϱ - ExecuteOutlookProcess()

        /// <summary>
        /// ƿ μ ϱ
        /// </summary>
        private static void ExecuteOutlookProcess()
        {
            try
            {
                Process.Start(_outlookFileName);
            }
            catch
            {
            }
        }

        #endregion
    }
}