﻿using System;

namespace TestProject
{
    /// <summary>
    /// 로그 헬퍼 인터페이스
    /// </summary>
    public interface ILogHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method

        #region 메시지 쓰기 - WriteMessage(message)

        /// <summary>
        /// 메시지 쓰기
        /// </summary>
        /// <param name="message">메시지</param>
        void WriteMessage(string message);

        #endregion
        #region 로그 쓰기 - WriteLog(format, parameterArray)

        /// <summary>
        /// 로그 쓰기
        /// </summary>
        /// <param name="format">포맷 문자열</param>
        /// <param name="parameterArray">매개 변수 배열</param>
        void WriteLog(string format, params object[] parameterArray);

        #endregion
        #region 에러 로그 쓰기 - WriteErrorLog(exception, caption)

        /// <summary>
        /// 에러 로그 쓰기
        /// </summary>
        /// <param name="exception">예외</param>
        /// <param name="caption">제목 문자열</param>
        void WriteErrorLog(Exception exception, string caption);

        #endregion
        #region 에러 로그 쓰기 - WriteErrorLog(exception, caption)

        /// <summary>
        /// 에러 로그 쓰기
        /// </summary>
        /// <param name="message">예외 메시지</param>
        /// <param name="caption">제목 문자열</param>
        void WriteErrorLog(string message, string caption);

        #endregion
        #region 덤프 로그 쓰기 - WriteDumpLog(sourceObject, caption)

        /// <summary>
        /// 덤프 로그 쓰기
        /// </summary>
        /// <param name="sourceObject">예외</param>
        /// <param name="caption">제목 문자열</param>
        void WriteDumpLog(object sourceObject, string caption);

        #endregion
    }
}